Attribute VB_Name = "Module1"
Option Explicit

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageStr Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Declare Function SendMessageRef Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, wParam As Any, lParam As Any) As Long
Public Const WM_USER = &H400

' /* New masks and effects -- a parenthesized asterisk indicates that
'   the data is stored by RichEdit2.0, but not displayed */

Public Const CFM_SMALLCAPS = &H40&                 ' /* (*)  */
Public Const CFM_ALLCAPS = &H80&                   ' /* (*)  */
Public Const CFM_HIDDEN = &H100&                   ' /* (*)  */
Public Const CFM_OUTLINE = &H200&                  ' /* (*)  */
Public Const CFM_SHADOW = &H400&                   ' /* (*)  */
Public Const CFM_EMBOSS = &H800&                   ' /* (*)  */
Public Const CFM_IMPRINT = &H1000&                 ' /* (*)  */
Public Const CFM_DISABLED = &H2000&
Public Const CFM_REVISED = &H4000&

Public Const CFM_BACKCOLOR = &H4000000
Public Const CFM_LCID = &H2000000
Public Const CFM_UNDERLINETYPE = &H800000         ' /* (*)  */
Public Const CFM_WEIGHT = &H400000
Public Const CFM_SPACING = &H200000               ' /* (*)  */
Public Const CFM_KERNING = &H100000               ' /* (*)  */
Public Const CFM_STYLE = &H80000                  ' /* (*)  */
Public Const CFM_ANIMATION = &H40000              ' /* (*)  */
Public Const CFM_REVAUTHOR = &H8000&

Public Const CFE_SUBSCRIPT = &H10000               ' /* Superscript and subscript are */
Public Const CFE_SUPERSCRIPT = &H20000            ' /*  mutually exclusive           */

Public Const CFM_SUBSCRIPT = CFE_SUBSCRIPT Or CFE_SUPERSCRIPT
Public Const CFM_SUPERSCRIPT = CFM_SUBSCRIPT

'Public Const CFM_EFFECTS2 = (CFM_EFFECTS Or CFM_DISABLED Or CFM_SMALLCAPS Or CFM_ALLCAPS _
'                    Or CFM_HIDDEN Or CFM_OUTLINE Or CFM_SHADOW Or CFM_EMBOSS _
'                    Or CFM_IMPRINT Or CFM_DISABLED Or CFM_REVISED _
'                    Or CFM_SUBSCRIPT Or CFM_SUPERSCRIPT Or CFM_BACKCOLOR)

'Public Const CFM_ALL2 = (CFM_ALL Or CFM_EFFECTS2 Or CFM_BACKCOLOR Or CFM_LCID _
'                    Or CFM_UNDERLINETYPE Or CFM_WEIGHT Or CFM_REVAUTHOR _
'                    Or CFM_SPACING Or CFM_KERNING Or CFM_STYLE Or CFM_ANIMATION)

Public Const CFE_SMALLCAPS = CFM_SMALLCAPS
Public Const CFE_ALLCAPS = CFM_ALLCAPS
Public Const CFE_HIDDEN = CFM_HIDDEN
Public Const CFE_OUTLINE = CFM_OUTLINE
Public Const CFE_SHADOW = CFM_SHADOW
Public Const CFE_EMBOSS = CFM_EMBOSS
Public Const CFE_IMPRINT = CFM_IMPRINT
Public Const CFE_DISABLED = CFM_DISABLED
Public Const CFE_REVISED = CFM_REVISED

' /* NOTE: CFE_AUTOCOLOR and CFE_AUTOBACKCOLOR correspond to CFM_COLOR and
'   CFM_BACKCOLOR, respectively, which control them */
Public Const CFE_AUTOBACKCOLOR = CFM_BACKCOLOR

' /* Underline types */
Public Const CFU_CF1UNDERLINE = &HFF&      ' /* map charformat's bit underline to CF2.*/
Public Const CFU_INVERT = &HFE&            ' /* For IME composition fake a selection.*/
Public Const CFU_UNDERLINEDOTTED = &H4&    ' /* (*) displayed as ordinary underline  */
Public Const CFU_UNDERLINEDOUBLE = &H3&    ' /* (*) displayed as ordinary underline  */
Public Const CFU_UNDERLINEWORD = &H2&      ' /* (*) displayed as ordinary underline  */
Public Const CFU_UNDERLINE = &H1&
Public Const CFU_UNDERLINENONE = 0&

' /* CHARFORMAT masks */
Public Const CFM_BOLD = &H1
Public Const CFM_ITALIC = &H2
Public Const CFM_UNDERLINE = &H4
Public Const CFM_STRIKEOUT = &H8
Public Const CFM_PROTECTED = &H10
Public Const CFM_LINK = &H20&                  ' /* Exchange hyperlink extension */
Public Const CFM_SIZE = &H80000000
Public Const CFM_COLOR = &H40000000
Public Const CFM_FACE = &H20000000
Public Const CFM_OFFSET = &H10000000
Public Const CFM_CHARSET = &H8000000

' /* CHARFORMAT effects */
Public Const CFE_BOLD = &H1&
Public Const CFE_ITALIC = &H2&
Public Const CFE_UNDERLINE = &H4&
Public Const CFE_STRIKEOUT = &H8&
Public Const CFE_PROTECTED = &H10&
Public Const CFE_LINK = &H20&
Public Const CFE_AUTOCOLOR = &H40000000       ' /* NOTE: this corresponds to */
                                        ' /* CFM_COLOR, which controls it */
Public Const yHeightCharPtsMost = 1638&

' /* RichEdit messages */

' #ifndef WM_CONTEXTMENU
Public Const WM_CONTEXTMENU = &H7B&
' #End If

' #ifndef WM_PRINTCLIENT
Public Const WM_PRINTCLIENT = &H318&
' #End If

' #ifndef EM_GETLIMITTEXT
'public Const EM_GETLIMITTEXT = (WM_USER + 37)
' #End If

' #ifndef EM_POSFROMCHAR
'public Const EM_POSFROMCHAR = (WM_USER + 38)
'public Const EM_CHARFROMPOS = (WM_USER + 39)
' #End If

' #ifndef EM_SCROLLCARET
'public Const EM_SCROLLCARET = (WM_USER + 49)
' #End If
Public Const EM_CANPASTE = (WM_USER + 5yi If
Public wweALIC = &H2&
PubM_USER  N &H10&
Public ublic Const EM_CANPASTE = (WM_USER + 5yi If
PuSCFM_IM_U = &H7B&
' #End IS7B&
' Const If
PuSCFM_IM_U = &H7B&
' #End CFM_Reich RBH7B&&&&d CFM_ReE = (WM_USER + 5yi If
ePublic uz6CHAA_Reich RBH7B&&&&d CFM_teE = (WM_USER + 5yi I6nd If

' #f
PAAXT ......   ' /* (*)  */
PublR= (WM_UWEIichR' ubL(WM_USER + 39)
' #"+ 5yi If
Public wweALEM_SCROLLCARET
'puwcConst enst EM_CANPAStSTE NPublic Const CFM_h.....   ' /*If
ePublm2oU+ 5yi If&H10&
Public ubliceEB.....   ' /*If
ePublm2oU8ePublm2oU+ 5yi If&H1      ER + 5yi I6nd I 
Public ubliceEB2st EM_XXT  corAs LonIoY
' reDmU
PublicpBteSER + 5yi w6nd I 
Punf&fpRgAe COLOCAR'Iaf'T U
P 
e'T EN&&d IdTH7B&&&&d lic ubliCC I 
PaEM_CANPASTE = (WM_USERelsE =lERAf&H10&t/aY'LOCAR'Iaf'T U
P 
e'T Epr w6nvSn(' u6
e'T Epr w6nvSn('  ERA/
PubCANPASTU_INNw6nvSn(' u6
e'T Epr w6Val lParam As Long) As LyCn('  ERnvSnAStSTEParam AsnASt u6
e'T Epr w6Val lParamSt  If&H10&
Public ublicXXT  corAs LonIoY
'NS= &H8&FE&ENBSteCaramSt rm (*) displayed as ordmSt rm HARI6nvSn(' u6
e'T gR +eParam As Long) As L7UuI6nvSnt
SA ocdaM_StmSt  If&H10&
PubliliceEB.UuI
' sblicvSnt
SA ocdaM_St5v
PubliliY ceEB.UuI
' sblddtn0&
PubliliceEB.UuI
SFROANPASTU(u
SA ocdaMUSe8' /* Underline typesTSTU(    ER erline tSTU(    ER eRe ubM_USER  N &H1reWn